/* Tabela TIPOOPEROPL: Cadastro de Tipo de Operao de Operador Logstico */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela TIPOOPEROPL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela TIPOOPEROPL,
             utilizando a tabela Geral de Logs de Operaes */
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_DFS_TIPOOPEROPL' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

   DROP TRIGGER LOG_DFS_TIPOOPEROPL
GO

CREATE TRIGGER LOG_DFS_TIPOOPEROPL ON TIPOOPEROPL
FOR UPDATE,INSERT, DELETE
AS
BEGIN
  DECLARE @V_USUARIO             VARCHAR(40);
  DECLARE @V_TIPO                VARCHAR(1);
  DECLARE @V_TPMOVI              VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_CDFILLOGOPER        VARCHAR(4);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  DECLARE @V_DTOPER              DATETIME;

  DECLARE @V_CDFILIOPELOG_NEW    VARCHAR(4);
  DECLARE @V_CDFILDEST_NEW       VARCHAR(4);
  DECLARE @V_CDTIPOOPERSAID_NEW  VARCHAR(2);
  DECLARE @V_IDTIPOOPERSAID_NEW  VARCHAR(1);
  DECLARE @V_CDTIPOOPERENTR_NEW  VARCHAR(2);
  DECLARE @V_IDTIPOOPERENTR_NEW  VARCHAR(1);

  DECLARE @V_CDFILIOPELOG_OLD    VARCHAR(4);
  DECLARE @V_CDFILDEST_OLD       VARCHAR(4);
  DECLARE @V_CDTIPOOPERSAID_OLD  VARCHAR(2);
  DECLARE @V_IDTIPOOPERSAID_OLD  VARCHAR(1);
  DECLARE @V_CDTIPOOPERENTR_OLD  VARCHAR(2);
  DECLARE @V_IDTIPOOPERENTR_OLD  VARCHAR(1);

  SET @V_TIPO = '0';
  SET @V_DESC = '';
  SET @V_CDFILLOGOPER = '';
  SET @V_USUARIO = '-';


  DECLARE C_CURSOR_CR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDFILIOPELOG,
         CDFILDEST,
         CDTIPOOPERSAID,
         IDTIPOOPERSAID,
         CDTIPOOPERENTR,
         IDTIPOOPERENTR
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDFILIOPELOG,
         INSERTED.CDFILDEST,
         INSERTED.CDTIPOOPERSAID,
         INSERTED.IDTIPOOPERSAID,
         INSERTED.CDTIPOOPERENTR,
         INSERTED.IDTIPOOPERENTR,
         DELETED.CDFILIOPELOG,
         DELETED.CDFILDEST,
         DELETED.CDTIPOOPERSAID,
         DELETED.IDTIPOOPERSAID,
         DELETED.CDTIPOOPERENTR,
         DELETED.IDTIPOOPERENTR
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIOPELOG = DELETED.CDFILIOPELOG    AND
         INSERTED.CDFILDEST  = DELETED.CDFILDEST

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDFILIOPELOG,
         INSERTED.CDFILDEST,
         INSERTED.CDTIPOOPERSAID,
         INSERTED.IDTIPOOPERSAID,
         INSERTED.CDTIPOOPERENTR,
         INSERTED.IDTIPOOPERENTR,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_CR;
   FETCH NEXT FROM C_CURSOR_CR   INTO @V_TIPO, @V_CDFILIOPELOG_NEW, @V_CDFILDEST_NEW,@V_CDTIPOOPERSAID_NEW,
                                      @V_IDTIPOOPERSAID_NEW, @V_CDTIPOOPERENTR_NEW, @V_IDTIPOOPERENTR_NEW,


                                      @V_CDFILIOPELOG_OLD, @V_CDFILDEST_OLD, @V_CDTIPOOPERSAID_OLD,
                                      @V_IDTIPOOPERSAID_OLD,@V_CDTIPOOPERENTR_OLD,@V_IDTIPOOPERENTR_OLD;


   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_TIPO = 'D' BEGIN
         IF @V_CDFILIOPELOG_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'OL=' + @V_CDFILIOPELOG_OLD;
         END;

         IF @V_CDFILDEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Filial Dest.=' + @V_CDFILDEST_OLD;
         END;

         IF @V_CDTIPOOPERSAID_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Saida OL=' + @V_CDTIPOOPERSAID_OLD;
         END;

         IF @V_IDTIPOOPERSAID_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Id Saida Ol=' + @V_IDTIPOOPERSAID_OLD;
         END;

         IF @V_CDTIPOOPERENTR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Entr. OL=' + @V_CDTIPOOPERENTR_OLD;
         END;

         IF @V_IDTIPOOPERENTR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Id Entr. OL=' + @V_IDTIPOOPERENTR_OLD;
         END;

         SET @V_TPMOVI       = '3';
         SET @V_ITPESQ       = @V_CDFILIOPELOG_OLD+@V_CDFILDEST_OLD;
         SET @V_CDFILLOGOPER = @V_CDFILIOPELOG_OLD;
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
            IF (@V_CDTIPOOPERSAID_OLD <> @V_CDTIPOOPERSAID_NEW) OR
               (@V_IDTIPOOPERSAID_OLD  <> @V_IDTIPOOPERSAID_NEW)  OR
               (@V_CDTIPOOPERENTR_OLD    <> @V_CDTIPOOPERENTR_NEW)OR
               (@V_IDTIPOOPERENTR_OLD  <> @V_IDTIPOOPERENTR_NEW) BEGIN

               SET @V_TPMOVI       = '2';
               SET @V_ITPESQ       = @V_CDFILIOPELOG_OLD+@V_CDFILDEST_OLD;
               SET @V_CDFILLOGOPER = @V_CDFILIOPELOG_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TPMOVI        = '1';
            SET @V_ITPESQ        = @V_CDFILIOPELOG_NEW+@V_CDFILDEST_NEW;
            SET @V_CDFILLOGOPER  = @V_CDFILIOPELOG_NEW;
         END;

         IF @V_CDFILIOPELOG_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'OL=' + @V_CDFILIOPELOG_NEW;
         END;

         IF @V_CDFILDEST_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Filial Dest.=' + @V_CDFILDEST_NEW;
         END;

         IF @V_CDTIPOOPERSAID_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Saida OL=' + @V_CDTIPOOPERSAID_NEW;
         END;

         IF @V_IDTIPOOPERSAID_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Id Saida Ol=' + @V_IDTIPOOPERSAID_NEW;
         END;

         IF @V_CDTIPOOPERENTR_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Entr. OL=' + @V_CDTIPOOPERENTR_NEW;
         END;

         IF @V_IDTIPOOPERENTR_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Id Entr. OL=' + @V_IDTIPOOPERENTR_NEW;
         END;

      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR,
                         @V_DSREMOTEHOST,
                         @V_DSSERVERRDM,
                         @V_DSSERVMETHOD,
                         @V_DSREMOTEOPER;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   CDFILLOGOPER,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('TIPOOPEROPL',
                   @V_DTOPER,
                   @V_USUARIO,
                   @V_TPMOVI,
                   @V_ITPESQ,
                   SUBSTRING(@V_DESC,1,300),
                   @V_CDFILLOGOPER,
                   @V_DSSERVERRDM,
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR_CR   INTO @V_TIPO, @V_CDFILIOPELOG_NEW, @V_CDFILDEST_NEW,@V_CDTIPOOPERSAID_NEW,
                                         @V_IDTIPOOPERSAID_NEW, @V_CDTIPOOPERENTR_NEW, @V_IDTIPOOPERENTR_NEW,


                                         @V_CDFILIOPELOG_OLD, @V_CDFILDEST_OLD, @V_CDTIPOOPERSAID_OLD,
                                         @V_IDTIPOOPERSAID_OLD,@V_CDTIPOOPERENTR_OLD,@V_IDTIPOOPERENTR_OLD;
   END;
   CLOSE C_CURSOR_CR;
   DEALLOCATE C_CURSOR_CR;
END;
GO